<?php
namespace Services;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class AprovaSolemergprodProcedure extends StoredProcedure {

	public function __construct(Connection $connection, $procedureName = 'APROVA_SOLEMERGPROD') {
		parent::__construct($connection, $procedureName);
	}
	public function executeProcedure($row) {
		
		$this->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $row["CDFILIAL"]));
		$this->addParam(new Param('P_NRSOLEMERGPROD', Param::PARAM_INPUT, $row["NRSOLEMERGPROD"]));
		$this->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $row["CDOPERADOR"]));
		$this->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $row["NRORG"]));
		$this->addParam(new Param('P_NRLISTAERROS', Param::PARAM_OUTPUT, null, null, 20));
		$result = $this->execute();
		// clear params
		$this->params = array();
		return $result;
	}
}