<?php
namespace Services;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class GerarPrevisaoProcedure extends StoredProcedure {

	public function __construct(Connection $connection, $procedureName = 'GERA_PREVPAX_PROD') {
		parent::__construct($connection, $procedureName);
	}

	public function executeProcedure($P_CDFILIAL, $P_CDFILIPROC, $P_DATAINI, $P_DATAFIN, $P_SUBSTITUI_JA_GERADOS, $P_CDOPERADOR, $P_NRORG) {

		$this->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $P_CDFILIAL));
		$this->addParam(new Param('P_CDFILIPROC', Param::PARAM_INPUT, $P_CDFILIPROC));
		$this->addParam(new Param('P_DATAINI', Param::PARAM_INPUT, $P_DATAINI));
		$this->addParam(new Param('P_DATAFIN', Param::PARAM_INPUT, $P_DATAFIN));
		$this->addParam(new Param('P_SUBSTITUI_JA_GERADOS', Param::PARAM_INPUT, $P_SUBSTITUI_JA_GERADOS));
		$this->addParam(new Param('P_CDOPERADOR', Param::PARAM_INPUT, $P_CDOPERADOR));
		$this->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $P_NRORG));
	    $this->addParam(new Param('P_NRLISTAERROS', Param::PARAM_OUTPUT, null, null, 20));
	    $result = $this->execute();
		// clear params
		$this->params = array();
		return $result;
	}
}