<?php

namespace Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Doctrine\DBAL\Connection;

class UserAdService {

    /**
     * @var User
     */
    private $user;
    /**
     * @var Password
     */
    private $pwd;
    /**
     * @var Environment
     */
    private $environment;
    /**
     * @var ActiveDirectory
     */
    private $adService;

    public function __construct($adService, $environment) {
        $this->adService   = $adService;
        $this->environment = $environment;
    }

    /**
     * @param $User
     */
    protected function setUser($user){
        $this->user = $user;
    }

    /**
     * @param $Password
     */
    protected function setPwd($pwd){
        $this->pwd = $pwd;
    }

    /**
     * @param $request
     * @param $response
     */
    public function userAutenticar($request, $response) {
        try {
            $filter = $request->getFilterCriteria()->getConditions();
            $this->setUser($filter[0]['value']);
            $this->setPwd($filter[1]['value']);
            $this->auth();
            $response->addDataSet(new DataSet('userValid', array(true)));
        }catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

    private function auth(){
        $this->adService->login($this->user, $this->pwd, $this->environment->getNrOrgTrab());
    }
}