/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_REFOREG                                                  */
/* Tabela : REFOREG                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 03/03/2004 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
             o.name = 'DTULTATU_REFOREG'  and
             type = 'TR'                  and
             u.uid = o.uid                and
             u.name = USER)
DROP TRIGGER DTULTATU_REFOREG
GO

CREATE TRIGGER DTULTATU_REFOREG
ON REFOREG
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'REFOREG', 'CDREGIAO='  + CDREGIAO +
                                  ';CDFORNECED='+ CDFORNECED+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE REFOREG
      SET DTULTATUFREG = GETDATE()
      FROM INSERTED
      WHERE ISNULL(REFOREG.CDREGIAO,0)   = ISNULL(INSERTED.CDREGIAO,0) and
            ISNULL(REFOREG.CDFORNECED,0) = ISNULL(INSERTED.CDFORNECED,0);
   END;
END
;
GO